import { buildUUID } from '../../../utils/uuid';
import { ApiAction, ApiActionPage } from '../../model/baseModel';
import {
  FactoryListItem,
  FactoryPageListGetResultModel,
  FactoryPageParams,
} from '../model/warehoueseModel';
import { genAction, Api, genActionPage } from '../system';
import { defHttp } from '/@/utils/http/axios';

/*
 * 获取角色分页列表
 */
export const getFactoryListByPage = async (params: FactoryPageParams) => {
  let sqlcmd = '';
  if (params?.FACTORY_CODE != undefined && params?.FACTORY_CODE != '') {
    sqlcmd += " And FTY_CODE = '" + params?.FACTORY_CODE + "'";
  }
  if (params?.FACTORY_NAME != undefined && params?.FACTORY_NAME != '') {
    sqlcmd += "And FTY_NAME like '%" + params?.FACTORY_NAME + "%'";
  }
  const rParams = genActionPage('MES_FACTORY', sqlcmd, params.page, params.pageSize);
  return getFactoryListByPageAsync(rParams);
};
async function getFactoryListByPageAsync(params: ApiActionPage) {
  const data = await defHttp.post<ApiActionPage>(
    { url: Api.EntityPageList, params },
    {
      isTransformResponse: false,
    },
  );
  const model: FactoryPageListGetResultModel = {
    items: data.Data.data,
    total: data.Data.totals,
  };
  return model;
}

export const SaveFactory = async (params: FactoryListItem, isUpdate: boolean) => {
  let data;
  if (isUpdate) {
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('MES_FACTORY', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    params.ID = buildUUID(); //生成GUID
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('MES_FACTORY', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  }
  return data;
};

export const DeleteFactory = async (params: Recordable) => {
  const usParams = genAction('FACTORY', [params]);
  return await defHttp.post(
    { url: Api.DeleteList, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
    },
  );
};
